config/routes.rb
Rails.application.routes.draw do
  get '/login', to: 'sessions#new'
  post '/login', to: 'sessions#create'
  delete '/logout', to: 'sessions#delete'
  get 'home/index'

  resources :requests do
    post 'confirm'
  end
  resources :users
  resources :sessions, only: [:create]

  root 'home#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/icp_record.rb
class IcpRecord < ApplicationRecord
end

app/models/register_serial.rb
class RegisterSerial < ApplicationRecord
end

app/models/request.rb
class Request < ApplicationRecord

  scope :admin_confirmed, -> { where(admin_confirm: true)}
  scope :admin_unconfirmed, -> { where(admin_confirm: false)}

  validates :customer_name,
            presence: { message: "Please provide your name"}
  validates :email,
            presence: { message: "Please provide your email address"},
            format: { with: /.*@.*/, message: "Email must contain an @ symbol"}
  validates :phone,
            presence: { message: "Please provide your phone number"},
            format: { with: /\A[0-9]+\z/, message: "Digits only for phone number"}
  validates :customer_address1,
            presence: { message: "Please provide your street address"}
  validates :customer_postcode,
            presence: { message: "Please provide your postcode"},
            length: { is: 4, message: "Postcodes are 4 digits" }
  validates :customer_city,
            presence: { message: "Please list your city"}
  validates :customer_icp,
            presence: { message: "Please provide your ICP"},
            length: { is: 15, message: "ICP numbers are 15 digits/characters"}
end

app/models/user.rb
class User < ApplicationRecord
  validates :username,
            presence: { message: "Please enter username"},
            uniqueness: {case_sensitive: false, message: " already exists"}

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base

  helper_method :current_user
  helper_method :user_is_admin?
  helper_method :redirect_unauthorized

  def current_user
    User.find_by(id: session[:user_id])
  end

  def user_is_admin?
    current_user.admin?
  end

  def redirect_unauthorized
    unless current_user && user_is_admin?
      redirect_to :login, notice: "Only administrators can access this page"
    end
  end

end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end
end

app/controllers/requests_controller.rb
class RequestsController < ApplicationController
  before_action :redirect_unauthorized, except: [:new, :create]

  def index
    @requests = Request.all
  end

  def show
    @request = Request.find(params[:id])
    @icp_records = IcpRecord.all
  end

  def new
    @request = Request.new
  end

  def create
    @request = Request.new(request_params)
    #check if ICP needs admin scrutiny
    if IcpCheckService.new(@request.customer_icp).call
      @request.extra_scrutiny = true
    end

    if @request.save
      redirect_to @request
    else
      render 'new'
    end
  end

  def confirm
    Request.update(params[:request_id], admin_confirm: params[:admin_confirm])
    redirect_to :requests
  end

  private
  def request_params
    params.require(:request).permit(
      :customer_name,
      :email,
      :phone,
      :customer_address1,
      :customer_address2,
      :customer_suburb,
      :customer_postcode,
      :customer_city,
      :customer_icp
    )
  end
end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController

  def new
  end

  def create
    @user = User.find_by(username: params[:session][:username])
    if @user
      session[:user_id] = @user.id
      redirect_to @user
    else
      @errors = ActiveModel::Errors.new(self)
      @errors.add(:base, "Username does not exist")
      render 'new'
    end
  end

  def delete
    reset_session
    redirect_to login_url
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :redirect_unauthorized, except: [:show]

  def index
    @users = User.all
  end

  def new
    @user = User.new
  end

  def show
    @user = User.find(params[:id])
  end

  def create
    @user = User.new(user_params)
    if @user.save
      redirect_to @user
    else
      render 'new'
    end
  end

  private
    def user_params
      params.require(:user).permit(
          :username,
          :name
      )
    end
end

app/views/home/index.html.erb
<h1 class="banner">Minishop</h1>
<%= link_to 'Apply for electricity', {controller: 'requests', action: 'new'}, class: "nav_link" %><br>
<%= link_to 'Create new user', {controller: 'users', action: 'new'}, class: "nav_link" %><br>
<%= link_to 'Log in', {controller: 'sessions', action: 'create'}, class: "nav_link" %>

<%= render 'shared/nav' %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>MinishopPhase1</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/requests/index.html.erb
<h1>All Unconfirmed Requests</h1>

<table>
  <tr>
    <th>Name</th>
    <th>Email</th>
    <th>Phone</th>
    <th>Address 1</th>
    <th>Address 2</th>
    <th>Suburb</th>
    <th>Postcode</th>
    <th>City</th>
    <th>ICP</th>
    <th>Extra Scrutiny</th>
  </tr>

  <% @requests.admin_unconfirmed.each do |request| %>
    <tr class="<%= 'alert' if request.extra_scrutiny && !request.admin_confirm %>">
      <td><%= request.customer_name %></td>
      <td><%= request.email %></td>
      <td><%= request.phone %></td>
      <td><%= request.customer_address1 %></td>
      <td><%= request.customer_address2 %></td>
      <td><%= request.customer_suburb %></td>
      <td><%= request.customer_postcode %></td>
      <td><%= request.customer_city %></td>
      <td><%= request.customer_icp %></td>
      <td class="<%= 'alert_cell' if request.extra_scrutiny %>"><%= request.extra_scrutiny ? "Extra Scrutiny Required" : "None" %></td>
      <td><%= link_to 'Show', request_path(request) %></td>
    </tr>
  <% end %>
</table>

<h2>Confirmed Requests</h2>

<table>
  <tr>
    <th>Name</th>
    <th>Email</th>
    <th>Phone</th>
    <th>Address 1</th>
    <th>Address 2</th>
    <th>Suburb</th>
    <th>Postcode</th>
    <th>City</th>
    <th>ICP</th>
    <th>Extra Scrutiny</th>
  </tr>

  <% @requests.admin_confirmed.each do |request| %>
    <tr>
      <td><%= request.customer_name %></td>
      <td><%= request.email %></td>
      <td><%= request.phone %></td>
      <td><%= request.customer_address1 %></td>
      <td><%= request.customer_address2 %></td>
      <td><%= request.customer_suburb %></td>
      <td><%= request.customer_postcode %></td>
      <td><%= request.customer_city %></td>
      <td><%= request.customer_icp %></td>
      <td><%= request.extra_scrutiny ? "Extra Scrutiny Required" : "None" %></td>
      <td><%= link_to 'Show', request_path(request) %></td>
    </tr>
  <% end %>
</table>
<%= render 'shared/nav' %>

app/views/requests/new.html.erb
<h1>New Electricity Request</h1>

<%= form_with scope: :request, url: requests_path, local: true do |form| %>

  <% if @request.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@request.errors.count, "field") %>  need to be amended before your request can be submitted:
      </h2>
      <ul>
        <% @request.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <p>
    <%= form.label :customer_name %><br>
    <%= form.text_field :customer_name %>
  </p>

  <p>
    <%= form.label :email %><br>
    <%= form.text_field :email %>
  </p>
  <p>
    <%= form.label :phone %><br>
    <%= form.text_field :phone %>
  </p>

  <p>
    <%= form.label :customer_address1 %><br>
    <%= form.text_field :customer_address1 %>
  </p>
  <p>
    <%= form.label :customer_address2 %><br>
    <%= form.text_field :customer_address2 %>
  </p>
  <p>
    <%= form.label :customer_suburb %><br>
    <%= form.text_field :customer_suburb %>
  </p>
  <p>
    <%= form.label :customer_postcode %><br>
    <%= form.text_field :customer_postcode %>
  </p>
  <p>
    <%= form.label :customer_city %><br>
    <%= form.text_field :customer_city %>
  </p>
  <p>
    <%= form.label :customer_icp %><br>
    <%= form.text_field :customer_icp %>
  </p>

  <p>
    <%= form.submit %>
  </p>

<% end %>
<%= render 'shared/nav' %>

app/views/requests/show.html.erb
<h1>Request for <%= @request.customer_name %></h1>

<p>
  <label class="bold">Name:</label>
  <%= @request.customer_name %>
</p>
<p>
  <label class="bold">Email:</label>
  <%= @request.email %>
</p>
<p>
  <label class="bold">Phone:</label>
  <%= @request.phone %>
</p>
<p>
  <label class="bold">Address 1:</label>
  <%= @request.customer_address1 %>
</p>
<p>
  <label class="bold">Address 2:</label>
  <%= @request.customer_address2 %>
</p>
<p>
  <label class="bold">Suburb:</label>
  <%= @request.customer_suburb %>
</p>
<p>
  <label class="bold">Postcode:</label>
  <%= @request.customer_postcode %>
</p>
<p>
  <label class="bold">City:</label>
  <%= @request.customer_city %>
</p>
<p>
  <label class="bold">ICP:</label>
  <%= @request.customer_icp %>
</p>

<p>
  <% if !@request.admin_confirm %>
    <%= button_to "Confirm Valid ICP", request_confirm_path(request_id: @request.id, admin_confirm: true), method: :post %>
  <% else %>
    <%= button_to "Revoke ICP Confirmation", request_confirm_path(request_id: @request.id, admin_confirm: false), method: :post %>
  <% end %>
</p>

<h2>Known ICPs</h2>

<table>
  <tr>
    <th>ICP</th>
    <th>Address 1</th>
    <th>Address 2</th>
    <th>Suburb</th>
    <th>City</th>
  </tr>

  <% @icp_records.each do |icp_record| %>
    <tr>
      <td><%= icp_record.ICP %></td>
      <td><%= icp_record.address1 %></td>
      <td><%= icp_record.address2 %></td>
      <td><%= icp_record.suburb %></td>
      <td><%= icp_record.city %></td>
    </tr>
  <% end %>
</table>

<%= render 'shared/nav' %>

app/views/shared/_nav.html.erb
<div>
  <p>
    ---
  </p>
  <span>
    <% @user_state = current_user %>
    <%= @user_state ? "Logged in as: " + @user_state.username : "Not logged in" %>

    <%= link_to 'Home', {controller: 'home', action: 'index'}, class: "nav_link" %>

    <% if @user_state %>
      <%= link_to 'Profile', {controller: 'users', action: 'show', id: @user_state.id}, class: "nav_link" %>
      <%= link_to 'Logout', logout_path, method: :delete, class: "nav_link" %>
    <% else %>
      <%= link_to 'Log in', {controller: 'sessions', action: 'create'}, class: "nav_link" %>
    <% end %>
     |
    <% if @user_state && user_is_admin? %>
      <%= link_to 'Review Requests', {controller: 'requests', action: 'index'}, class: "nav_link" %>
      <%= link_to 'Create a User', {controller: 'users', action: 'new'}, class: "nav_link" %>
      <%= link_to 'All Users', {controller: 'users', action: 'index'}, class: "nav_link" %>
    <% end %>
  </span>
</div>

app/views/users/index.html.erb
<h1>All Users</h1>

<table>
  <tr>
    <th>Username</th>
    <th>Name</th>
    <th>Admin status</th>
  </tr>

  <% @users.each do |user| %>
    <tr>
      <td><%= user.username %></td>
      <td><%= user.name %></td>
      <td><%= user.admin ? "Admin" : "Not Admin" %></td>
    </tr>
  <% end %>
</table>
<%= render 'shared/nav' %>

app/views/users/new.html.erb
<h1>New User Creation</h1>

<%= form_with scope: :user, url: users_path, local: true do |form| %>

  <% if @user.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@user.errors.count, "field") %>  need to be amended before your user can be created:
      </h2>
      <ul>
        <% @user.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <p>
    <%= form.label :username %><br>
    <%= form.text_field :username %>
  </p>

  <p>
    <%= form.label :name %><br>
    <%= form.text_field :name %>
  </p>

  <p>
    <%= form.submit %>
  </p>

<% end %>
<%= render 'shared/nav' %>

app/views/users/show.html.erb
<p>
  <label class="bold">Username:</label>
  <%= @user.username %>
</p>
<p>
  <label class="bold">Name:</label>
  <%= @user.name %>
  <br>

  <label class="bold">Admin status:</label>
  <%= @user.admin ? "Admin" : "Not Admin" %>
</p>
<%= render 'shared/nav' %>